From foo@baz Tue Apr  9 12:12:43 2002
To: Greg KH <gregkh@suse.de>
Date: 24 Mar 2005 13:00:16 -08:00
From: mochel@digitalimplant.org
Subject: [usb] Fix up USB to use klist_node_attached() instead of list_empty() on lists that will go away.


Signed-off-by: Patrick Mochel <mochel@digitalimplant.org>
Signed-off-by: Greg Kroah-Hartman <gregkh@suse.de>


Index: gregkh-2.6/drivers/usb/core/usb.c
===================================================================
--- gregkh-2.6.orig/drivers/usb/core/usb.c	2005-04-20 21:37:47.000000000 -0700
+++ gregkh-2.6/drivers/usb/core/usb.c	2005-04-20 21:37:51.000000000 -0700
@@ -293,7 +293,7 @@
 	/* if interface was already added, bind now; else let
 	 * the future device_add() bind it, bypassing probe()
 	 */
-	if (!list_empty (&dev->bus_list))
+	if (!klist_node_attached (&dev->knode_bus))
 		device_bind_driver(dev);
 
 	return 0;
@@ -323,7 +323,7 @@
 		return;
 
 	/* don't disconnect from disconnect(), or before dev_add() */
-	if (!list_empty (&dev->driver_list) && !list_empty (&dev->bus_list))
+	if (!klist_node_attached(&dev->knode_driver) && !klist_node_attached(&dev->knode_bus))
 		device_release_driver(dev);
 
 	dev->driver = NULL;
